//Select is a UGen that acts as a server-side version of 'case.' See the help file on Control Structures for more information on 'case'.

//Select can run at the audio or control rate. It expects two arguments: an index and an Array of UGens. Select will output a UGen from its Array according to the specified index:

s.boot;

(
f = {
	arg index=0;
	var sig;
	sig = Select.ar(index, [SinOsc.ar(200), VarSaw.ar(800)]);
	sig = sig * 0.3;
};
)

//The argument 'index' is 0 by default, therefore we hear the 0th item of the Array, which is a 200Hz sine wave.
x = f.play;

//We can set the index to 1 to hear the 800Hz VarSaw instead.
x.set(\index, 1);

//When using Select, all UGens within its Array are running simultaneously, which may not be the most efficient solution. However, when using simple waves such as SinOsc and VarSaw, this is not a major concern.

s.freeAll;