//Real-Time Convolution in SuperCollider

s.makeGui.boot;
s.options.memSize = 2.pow(20);

~street = Buffer.readChannel(s, "/Users/eli/Desktop/street_noise_2.aiff", channels:[0]);
~piano = Buffer.readChannel(s, "/Users/eli/Desktop/piano_trail_01_m.aiff", channels:[0]);

//Convolution

//multiplication of amplitudes and phases
(
{
	var sig1, sig2, fsig1, fsig2, out;
	sig1 = PlayBuf.ar(1!2, ~street, loop:1);
	sig2 = PlayBuf.ar(1!2, ~piano, loop:1);
	fsig1 = FFT({LocalBuf(8192)}!2, sig1);
	fsig2 = FFT({LocalBuf(8192)}!2, sig2);

	//order of PV_Mul inputs is irrelevant
	fsig1 = PV_Mul(fsig1, fsig2);
	out = IFFT(fsig1);
	out = out * 0.5;
}.play
)

//multiplication of amplitudes only
(
{
	var sig1, sig2, fsig1, fsig2, fsig3, out;
	sig1 = PlayBuf.ar(1!2, ~street, loop:1);
	sig2 = PlayBuf.ar(1!2, ~piano, loop:1);
	fsig1 = FFT({LocalBuf(8192)}!2, sig1);
	fsig2 = FFT({LocalBuf(8192)}!2, sig2);

	//order of PV_MagMul args matters: phases from input 1 are used in the resulting FFT
	fsig3 = PV_MagMul(fsig2, fsig1);
	out = IFFT(fsig1);
	out = out * 0.2;
}.play
)

//Convolution UGen (very similar to PV_Mul)
(
{
	var sig1, sig2, conv;
	sig1 = PlayBuf.ar(1!2, ~street, loop:1);
	sig2 = PlayBuf.ar(1!2, ~piano, loop:1);
	//Impulse.ar(0);
	//sig2 = DC.ar(0.2);
	//sig2 = LFDClipNoise.ar * 0.02;
	conv = Convolution.ar(sig2, sig1, 8192, 0.2);
}.play
)